/********************************************************
 *  WINBOND W569 DEMO CODE
 *
 *  FILENAME:
 *    ArmHost_DemoCode_C_Decoder.c
 *
 *  MODIFICATION HISTORY:
 *    2004/08/02	created		by	CCChien0
 ********************************************************/

// DemoCode.c : Defines the entry point for the console application.
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <rt_misc.h>

#include "ArmDefine.h"
#include "TTypeLt.h"
#include "PlayEgn.h"
/*
#include "Anpanman.imf.h"
#include "paino.cmf.h"
#include "1kHz_8k_8bit_mono.apm.bin.h"
#include "Sin_1kHz_8k_8bit_mono.apm.bin.h"
#include "Sin_1kHz_8k_8bit_mono.pc8.h"
#include "OneSinWave_1kHz_8k_8bit_mono.pc8.h"
*/
//#define _FOR_FPGA
#define	NEW_EV_BOARD	1
//#define _DUMP

#ifdef _DUMP
#include "dumpcode.h"
#endif

#define	UINT8	unsigned char
#define	UINT16	unsigned short
#define	SINT32	int
#define	UINT32	unsigned int

__value_in_regs struct __initial_stackheap
__user_initial_stackheap( unsigned R0, unsigned SP, unsigned R2, unsigned SL )
{
  struct __initial_stackheap config;

  config.stack_base = 0x00080000;
  config.heap_base = 0x00040000;

  return config;
}

void
CPUHost_EnableW569Interrupt(  )
{
#ifdef	NEW_EV_BOARD
  *( ( volatile UINT32 * ) AIC_MECR ) = 0x20;
#else
  *( ( volatile UINT32 * ) AIC_MECR ) = 0x4;
#endif
}

void
CPUHost_DisableW569Interrupt(  )
{
#ifdef	NEW_EV_BOARD
  *( ( volatile UINT32 * ) AIC_MDCR ) = 0x20;
#else
  *( ( volatile UINT32 * ) AIC_MDCR ) = 0x4;
#endif
}

#ifdef	WIN32
void
IRQ_Handler(  )
#else
__irq void
IRQ_Handler(  )
#endif
{
  UINT32        dwISR;
  dwISR = ( *( volatile UINT32 * ) AIC_ISR );

#ifdef _DUMP
  Dump_WaitForFIFOInterrupt(  );
#endif

#ifdef	NEW_EV_BOARD
  if( dwISR & 0x20 )
  {                             // nIRQ0, External Interrupt 0
    W569_InterruptHandler(  );
    ( *( UINT32 * ) AIC_SCCR ) = 0x20;
  }
#else
  if( dwISR & 0x04 )
  {                             // nIRQ0, External Interrupt 0
    W569_InterruptHandler(  );
    ( *( UINT32 * ) AIC_SCCR ) = 0x04;
  }
#endif

  ( *( UINT32 * ) AIC_EOSCR ) = 0;

}

void
SetW569IOMapping(  )
{
  // map to External I/O 0
  UINT8         byRegValue[4];
  UINT32        dwRegValue;
  UINT32        dwOldVector;

  UINT32        dwBaseAddr = W569_IO_START_ADDR >> 18;
  byRegValue[0] = ( UINT8 ) ( ( dwBaseAddr >> 5 ) & 0xFF );
  byRegValue[1] =
      ( UINT8 ) ( ( dwBaseAddr & 0x1F ) << 3 ) | W569_IO_BANK_SIZE;
  byRegValue[2] =
      ( UINT8 ) ( ( W569_IO_ADDR_BUS_ALIGN << 7 ) | ( W569_IO_ACCESS_CYCLE <<
      3 ) | W569_IO_HOLD_ON_TIME );
  byRegValue[3] =
      ( UINT8 ) ( ( W569_IO_ADDRESS_SET_UP << 5 ) | ( W569_IO_CHIP_SEL_SET_UP
      << 2 ) );
  dwRegValue =
      ( ( UINT32 ) byRegValue[0] << 24 ) | ( ( UINT32 ) byRegValue[1] << 16 )
      | ( ( UINT32 ) byRegValue[2] << 8 ) | ( ( UINT32 ) byRegValue[3] );
  *( ( volatile UINT32 * ) EXT0CON ) = dwRegValue;

  byRegValue[3] = ( UINT8 ) ( ( W569_IO_ADDRESS_SET_UP << 5 ) |
      ( W569_IO_CHIP_SEL_SET_UP << 2 ) | W569_IO_DATA_BUS_WIDTH );
  dwRegValue = ( ( UINT32 ) byRegValue[0] << 24 ) |
      ( ( UINT32 ) byRegValue[1] << 16 ) |
      ( ( UINT32 ) byRegValue[2] << 8 ) | ( ( UINT32 ) byRegValue[3] );
  *( ( volatile UINT32 * ) EXT0CON ) = dwRegValue;

#ifdef	NEW_EV_BOARD
  // Set GPIO 20 type as IRQ3, GPIO 0~3 as Input
  *( ( volatile UINT32 * ) GPIO_CFG ) &= 0xFFCFFFFC;
  *( ( volatile UINT32 * ) GPIO_CFG ) |= 0x00100000;
  *( ( volatile UINT32 * ) DEBNCE_CTRL ) = 0x68;
  *( ( volatile UINT32 * ) AIC_SCR5 ) = 0x00000007;     // Low-level Trigger
#else
  // Set GPIO 17 type as IRQ0, GPIO 4~7 as Input
  // GPIO 0~3 as Output (7-segment LED 0)
  // GPIO 12~15 as Output (7-segment LED 1)
  *( ( volatile UINT32 * ) GPIO_CFG ) &= 0xFFFF03F0;
  *( ( volatile UINT32 * ) GPIO_CFG ) |= 0x00004000;
  *( ( volatile UINT32 * ) GPIO_DIR ) |= 0x0000F00F;
  *( ( volatile UINT32 * ) DEBNCE_CTRL ) = 0x61;
  *( ( volatile UINT32 * ) AIC_SCR2 ) = 0x00000007;     // Low-level Trigger
#endif

  // replace interrupt vector for IRQ0
  dwOldVector = *( volatile UINT32 * ) 0x38;
  ( *( volatile UINT32 * ) 0x38 ) = ( UINT32 ) IRQ_Handler;
}

void
CPUHost_WriteW569Command( UINT8 byData )
{
  ( *( volatile UINT8 * ) W569_STATUS_FLAG_REG ) = byData;
#ifdef _DUMP
  Dump_WriteCommand( byData );
#endif
}

void
CPUHost_WriteW569Data( UINT8 byData )
{
  ( *( volatile UINT8 * ) W569_DATA_REG ) = byData;
#ifdef _DUMP
  Dump_WriteData( byData );
#endif
}

UINT8
CPUHost_ReadW569Status(  )
{
  BYTE          byData = ( *( volatile UINT8 * ) W569_STATUS_FLAG_REG );
#ifdef _DUMP
  Dump_ReadData( byData );
#endif
  return byData;
}

UINT8
CPUHost_ReadW569Data(  )
{
  BYTE          byData = ( *( volatile UINT8 * ) W569_DATA_REG );
#ifdef _DUMP
  Dump_ReadStatus( byData );
#endif
  return byData;
}

void
ShowLED( BYTE byValue )
{
#ifndef	NEW_EV_BOARD
  *( volatile UINT32 * ) GPIO_DATAOUT =
      ( ( UINT32 ) ( byValue / 10 ) << 12 ) | ( UINT32 ) ( byValue % 10 );
#endif
}

#ifdef	NEW_EV_BOARD
#define INPUT_FLAG	0x0000000F
#if 0
#define	KEY1		0x00000002
#define	KEY2		0x00000008
#define	KEY3		0x00000004
#define	KEY4		0x00000001
#else
#define	KEY1		0x00000001
#define	KEY2		0x00000002
#define	KEY3		0x00000004
#define	KEY4		0x00000008
#endif
#else
#define INPUT_FLAG	0x000000F0
#define	KEY1		0x00000010
#define	KEY2		0x00000020
#define	KEY3		0x00000040
#define	KEY4		0x00000080
#endif

#ifdef LOCAL_TEST
UINT8         g_byPLL_ADJUST_M = 43;
UINT8         g_byPLL_ADJUST_N = 14;
#endif

UINT8        *g_pbyMelodyDataPtrInHost = ( UINT8 * ) 0x00100000;
UINT8        *g_pbyMelodyDataPtr = ( UINT8 * ) 0x7f060000;

UINT8
GetMaxSoundIndex(  )
{
  UINT8        *pbyHeader = g_pbyMelodyDataPtr;
  return pbyHeader[4];
}

UINT8
GetSoundIndex(  )
{
  UINT8        *pbyHeader = g_pbyMelodyDataPtr;
  UINT8        *pbyData = NULL;
  char          szMelodyName[256];

  BYTE          byCount = pbyHeader[4];
  WORD          wOffset = 3;
  DWORD         dwDataOffset = 0;
  BYTE          byNameLen = 0;
  WORD          j = 0;
  BYTE          i = 0;
  UINT8         k;

  for( i = 0; i < byCount; i++ )
  {
    dwDataOffset = ( DWORD ) pbyHeader[wOffset] |
        ( ( DWORD ) pbyHeader[wOffset + 1] << 8 ) |
        ( ( DWORD ) pbyHeader[wOffset + 2] << 16 ) |
        ( ( DWORD ) pbyHeader[wOffset + 3] << 24 );
    pbyData = &g_pbyMelodyDataPtr[dwDataOffset];
    byNameLen = pbyData[4];
    pbyData += 5;
    for( j = 0; j < ( WORD ) byNameLen; j++ )
      szMelodyName[j] = pbyData[j];
    szMelodyName[j] = 0;

    printf( "(%03d) %s\n", i + 1, szMelodyName );
    wOffset += 4;
  }
  printf( "\nSelect One: " );

  scanf( "%d", &k );
  return k;
}

int
SetLEDPattern( UINT8 byLEDMode, UINT8 byLEDType, UINT8 byLEDChannel,
    UINT8 byLEDBlink, int nIndex )
{
  UINT8        *pbyHeader = g_pbyMelodyDataPtr;
  BYTE          byCount = pbyHeader[5];
  WORD          wOffset;
  DWORD         dwDataOffset;
  UINT8        *pbyData;

  // printf("LEDPattern = %d\n", nIndex);
  nIndex--;
  if( ( nIndex < 0 ) || ( nIndex >= ( int ) byCount ) )
    return 0;

  wOffset = ( WORD ) ( 7 + ( ( int ) pbyHeader[4] + nIndex ) * 4 );
  dwDataOffset = ( DWORD ) pbyHeader[wOffset] |
      ( ( DWORD ) pbyHeader[wOffset + 1] << 8 ) |
      ( ( DWORD ) pbyHeader[wOffset + 2] << 16 ) |
      ( ( DWORD ) pbyHeader[wOffset + 3] << 24 );
  pbyData = &g_pbyMelodyDataPtr[dwDataOffset];

  // return W569_SetLEDMode(byLEDMode, byLEDType, byLEDChannel, byLEDBlink, pbyData);
}

int
SetMotorPattern( UINT8 byMotorMode, UINT8 byMotorType, UINT8 byMotorChannel,
    UINT8 byMotorBlink, int nIndex )
{
  UINT8        *pbyHeader = g_pbyMelodyDataPtr;
  BYTE          byCount = pbyHeader[6];
  WORD          wOffset;
  DWORD         dwDataOffset;
  UINT8        *pbyData;

  printf( "MotorPattern = %d\n", nIndex );

  nIndex--;
  if( ( nIndex < 0 ) || ( nIndex >= ( int ) byCount ) )
    return 0;

  wOffset =
      ( WORD ) ( 7 + ( ( int ) pbyHeader[4] + ( int ) pbyHeader[5] +
      nIndex ) * 4 );
  dwDataOffset =
      ( DWORD ) pbyHeader[wOffset] | ( ( DWORD ) pbyHeader[wOffset +
      1] << 8 ) | ( ( DWORD ) pbyHeader[wOffset +
      2] << 16 ) | ( ( DWORD ) pbyHeader[wOffset + 3] << 24 );
  pbyData = &g_pbyMelodyDataPtr[dwDataOffset];
  // return W569_SetMotorMode(byMotorMode, byMotorType, byMotorChannel, byMotorBlink, pbyData);
}

short
PlaySound( int nIndex )
{
  UINT8        *pbyHeader = g_pbyMelodyDataPtr;
  BYTE          byCount = pbyHeader[4];
  WORD          wOffset;
  DWORD         dwDataOffset;
  UINT8        *pbyData;
  DWORD         dwDataLen;
  DWORD         dwNameLen;
  BYTE          byNameLen;
  int           nFormat;
  UINT8         byLEDMode;
  UINT8         byLEDType;
  UINT8         byLEDChannel;
  UINT8         byLEDBlink;
  UINT8        *byLEDParameter = NULL;
  UINT8         byMotorMode;
  UINT8         byMotorType;
  UINT8         byMotorChannel;
  UINT8         byMotorBlink;
  UINT8        *byMotorParameter = NULL;
  UINT8        *pbyFileData;
  int           nFileSize;

  nIndex--;
  if( ( nIndex < 0 ) || ( nIndex >= ( int ) byCount ) )
    return 0;

  wOffset = ( WORD ) ( 7 + nIndex * 4 );
  dwDataOffset = ( DWORD ) pbyHeader[wOffset] |
      ( ( DWORD ) pbyHeader[wOffset + 1] << 8 ) |
      ( ( DWORD ) pbyHeader[wOffset + 2] << 16 ) |
      ( ( DWORD ) pbyHeader[wOffset + 3] << 24 );
  pbyData = &g_pbyMelodyDataPtr[dwDataOffset];
  dwDataLen = ( DWORD ) pbyData[0] |
      ( ( DWORD ) pbyData[1] << 8 ) |
      ( ( DWORD ) pbyData[2] << 16 ) | ( ( DWORD ) pbyData[3] << 24 );
  byNameLen = pbyData[4];

#ifdef _DUMP
  Dump_Initial( ( char * ) pbyData + 5, byNameLen );
#endif
  pbyData += ( 5 + ( UINT32 ) byNameLen );
  nFormat = ( int ) *pbyData++;
  byLEDMode = *pbyData++;
  byLEDType = *pbyData++;
  byLEDChannel = *pbyData++;
  byLEDBlink = *pbyData++;

  // printf("Melody Index = %d\n", nIndex + 1);
  // printf("LEDMode = %d\n", byLEDMode);
  // printf("LEDType = %d\n", byLEDType);
  // printf("LEDChannel = %d\n", byLEDChannel);
  // printf("LEDBlink = %d\n", byLEDBlink);

  if( byLEDMode == 4 )
  {
    SetLEDPattern( byLEDMode, byLEDType, byLEDChannel, byLEDBlink,
        *pbyData++ );
    dwDataLen--;
  }
  else
  {
    if( ( byLEDMode == 2 ) && ( ( byLEDType == 6 ) || ( byLEDType == 7 ) ) )
    {
      byLEDParameter = pbyData;
      pbyData += 3;
      dwDataLen -= 3;
    }
    // W569_SetLEDMode(byLEDMode, byLEDType, byLEDChannel, byLEDBlink, byLEDParameter);
  }
  byMotorMode = *pbyData++;
  byMotorType = *pbyData++;
  byMotorChannel = *pbyData++;
  byMotorBlink = *pbyData++;

  // printf("MotorMode = %d\n", byMotorMode);
  // printf("MotorType = %d\n", byMotorType);
  // printf("MotorChannel = %d\n", byMotorChannel);
  // printf("MotorBlink = %d\n", byMotorBlink);

  if( byMotorMode == 4 )
  {
    SetMotorPattern( byMotorMode, byMotorType, byMotorChannel, byMotorBlink,
        *pbyData++ );
    dwDataLen--;
  }
  else
  {
    if( ( byMotorMode == 2 ) && ( ( byMotorType == 6 )
        || ( byMotorType == 7 ) ) )
    {
      *byMotorParameter = *pbyData++;
      dwDataLen--;
    }
    // W569_SetMotorMode(byMotorMode, byMotorType, byMotorChannel, byMotorBlink, byMotorParameter);
  }

  // pbyFileData = pbyData;
  nFileSize = ( int ) ( dwDataLen - 14 - byNameLen );
  memcpy( g_pbyMelodyDataPtrInHost, pbyData, nFileSize );

  // Play(pbyFileData, nFileSize, 1);
  return W569_Play( g_pbyMelodyDataPtrInHost, nFileSize, 0 );
}

int
main( int argc, char *argv[] )
{
  SINT32        nRet = 0;
  short         nChannelID = 0;
  SINT32        nTemp;
  UINT32        dwCLKSEL;
  int           i = 0, j = 0;
  UINT32        dwDataIn = 0;
  BOOL          bPaused = FALSE;
  BOOL          bStopped = TRUE;
  BOOL          bModeChanged = FALSE;
  BOOL          bVolumeMode = FALSE;
  UINT8         byVolume = 0x1F;
  UINT32        dwPressCount = 0;
  UINT32        dwKey = 0;
  BYTE          byIndex = 1;
  BYTE          byPatternIndex = 0;
  BOOL          bLEDPhaseOn = FALSE;
  BYTE          abyLEDPattern[7][3] =
      { {0, 0, 1}, {0, 1, 0}, {1, 0, 0}, {0, 1, 1},
  {1, 0, 1}, {1, 1, 0}, {1, 1, 1}
  };
  BYTE          abyLEDPlayPattern[] = {
    0xF4, 0x01,                 /* 500 ms */
    0xFF, 0x00, 0x00,           /* (R,G,B) = (255, 0, 0) */
    0xF4, 0x01,                 /* 500 ms */
    0x00, 0xFF, 0x00,           /* (R,G,B) = (0, 255, 0) */
    0xF4, 0x01,                 /* 500 ms */
    0x00, 0x00, 0xFF,           /* (R,G,B) = (0, 0, 255) */
    0x00, 0x00
  };
  UINT8         byMaxIndex = GetMaxSoundIndex(  );
  // printf("Max Sound Index = %d\n", byMaxIndex);

#ifdef	_FOR_FPGA
  printf
      ( "Select system clock (2) 24MHz, (4) 48MHz, (6) 60MHz, (8) 80MHz : " );
  scanf( "%d", &nTemp );
#else
  nTemp = 8;
#endif
  dwCLKSEL = ( *( volatile UINT32 * ) CLKSEL );
  ( *( volatile UINT32 * ) CLKSEL ) =
      ( dwCLKSEL & 0xFFFFFFF0 ) | ( UINT32 ) nTemp;

#ifndef	WIN32
  __asm
  {
  MRS           nTemp, CPSR AND nTemp, nTemp, 0x7F MSR CPSR_c, nTemp}
#endif

#ifdef LOCAL_TEST
  printf        ( "\nEnter PLL_ADJUST_M : " );
  scanf( "%d", &nTemp );
  g_byPLL_ADJUST_M = nTemp;
  printf( "Enter PLL_ADJUST_N : " );
  scanf( "%d", &nTemp );
  g_byPLL_ADJUST_N = nTemp;
  printf( "\n" );
#endif
  printf( "Config W569 IO mapping...\n" );
  SetW569IOMapping(  );

  printf( "W569 Initialization...\n\n" );
  nRet = W569_Initialize(  );

#ifndef _LOCAL_TEST
  printf( "Enable W569 interrupt ...\n" );
  CPUHost_EnableW569Interrupt(  );
#endif
  W569_SetSpeakerVolume( 0x0F );
  W569_SetEqualizerVolume( 0x1f );
  // MIDI
  nRet = W569_Play( g_abypaino_cmf, sizeof( g_abypaino_cmf ), 0 );
  printf( "nRet=%d\n", nRet );
  // PLAY WAVE
  // nChannelID = W569_Play(g_abySin_1kHz_8k_8bit_mono_apm_bin,sizeof(g_abySin_1kHz_8k_8bit_mono_apm_bin),0);
  // nChannelID = W569_Play(sinwave,sizeof(sinwave),0);
  // nChannelID = W569_Play(OneSinWave,sizeof(OneSinWave),0);
  while( W569_IsPlaying( nChannelID ) ) ;
  printf( "Stop\n" );
  W569_Stop( nChannelID );
#ifdef	_FOR_FPGA
  while( 1 )
  {
    nChannelID = PlaySound( byIndex );
    while( W569_IsPlaying( nChannelID ) )
      continue;
    W569_Stop(  );
#ifdef _DUMP
    Dump_Close(  );
#endif
    if( byMaxIndex == byIndex )
      byIndex = 1;
    else
      byIndex++;
  };

#else
  j = 0;
  while( 1 )
  {
    if( !bStopped && !bPaused && !W569_IsPlaying( nChannelID ) )
    {
      W569_Stop( nChannelID );
      bStopped = TRUE;
#ifdef _DUMP
      Dump_Close(  );
#endif
    }

    for( i = 0; i < 60000; i++ ) ;
    if( bStopped )
    {
      j++;
      if( !bLEDPhaseOn && ( j == 100 ) )
      {
        // W569_SetLEDOnOff(abyLEDPattern[byPatternIndex][0],
        // abyLEDPattern[byPatternIndex][1],
        // abyLEDPattern[byPatternIndex][2]);
        byPatternIndex++;
        if( byPatternIndex == 7 )
          byPatternIndex = 0;
        j = 0;
        bLEDPhaseOn = TRUE;
      }
      if( bLEDPhaseOn && ( j == 15 ) )
      {
        // W569_SetLEDOnOff(0,0,0);
        j = 0;
        bLEDPhaseOn = FALSE;
      }
    }
    dwDataIn = *( volatile UINT32 * ) GPIO_DATAIN;

    if( ( dwDataIn & INPUT_FLAG ) != INPUT_FLAG )
    {                           // key pressed
      dwKey = dwDataIn;
      // wait until key released
      bModeChanged = FALSE;
      dwPressCount = 0;
      do
      {
        for( i = 0; i < 60000; i++ ) ;
        dwDataIn = *( volatile UINT32 * ) GPIO_DATAIN;
        if( !bModeChanged &
            ( ( dwDataIn & INPUT_FLAG ) == ( KEY1 | KEY2 | KEY3 ) ) )
        {
          dwPressCount++;
          if( dwPressCount > 100 )
          {
            bVolumeMode = !bVolumeMode;
            bModeChanged = TRUE;
            // if (bVolumeMode)
            // ShowLED(byVolume);
            // else
            // ShowLED(byIndex);
          }
        }
      }
      while( ( dwDataIn & INPUT_FLAG ) != INPUT_FLAG );
      if( bModeChanged )
        continue;
    }
    else
    {
      continue;
    }

    if( ( dwKey & ( KEY1 | KEY2 ) ) != ( KEY1 | KEY2 ) )
    {
      if( ( dwKey & KEY1 ) == 0 )
      {                         // GPIO4 - Key 1 pressed - Index Up
        if( bVolumeMode )
        {
          if( byVolume < 0x1F )
          {
            byVolume++;
            W569_SetEqualizerVolume( byVolume );
            // ShowLED(byVolume);
          }
          continue;
        }
        else
        {

          if( byIndex == byMaxIndex )
            byIndex = 1;
          else
            byIndex++;
        }
      }

      if( ( dwKey & KEY2 ) == 0 )
      {                         // GPIO5 - Key 1 pressed - Index Down
        if( bVolumeMode )
        {
          if( byVolume > 0 )
          {
            byVolume--;
            W569_SetEqualizerVolume( byVolume );
            // ShowLED(byVolume);
          }
          continue;
        }
        else
        {
          if( byIndex == 1 )
            byIndex = byMaxIndex;
          else
            byIndex--;
        }
      }

      // ShowLED(byIndex);
      if( !bStopped )
      {

        W569_Stop( nChannelID );
#ifdef _DUMP
        Dump_Close(  );
#endif
        /* 
         * switch(byIndex % 3) { case 0: SetLEDMode(4, 0, 0, 0, abyLEDPlayPattern); break; case 1: SetLEDMode(4, 25, 0, 0, abyLEDPlayPattern); break; case 2:
         * SetLEDMode(2, 7, 0, 0, &abyLEDPlayPattern[2]); break; } */
        nChannelID = PlaySound( byIndex );
        bStopped = FALSE;
        bPaused = FALSE;
      }
      continue;
    }

    if( ( dwKey & KEY4 ) == 0 )
    {                           // GPIO7 - Key 4 pressed - stop
      W569_Stop( nChannelID );
      bPaused = FALSE;
      bStopped = TRUE;
#ifdef _DUMP
      Dump_Close(  );
#endif
      continue;
    }

    if( ( dwKey & KEY3 ) == 0 )
    {                           // GPIO6 - Key 3 pressed - play/pause/resume
      if( !bPaused && W569_IsPlaying( nChannelID ) )
      {
        W569_Pause( nChannelID );
        bPaused = TRUE;
        continue;
      }
      if( bPaused )
      {
        W569_Resume( nChannelID );
        bPaused = FALSE;
        continue;
      }
      if( bStopped )
      {
        /* 
         * switch(byIndex % 3) { case 0: SetLEDMode(4, 0, 0, 0, abyLEDPlayPattern); break; case 1: SetLEDMode(4, 25, 0, 0, abyLEDPlayPattern); break; case 2:
         * SetLEDMode(2, 7, 0, 0, &abyLEDPlayPattern[2]); break; } */
        nChannelID = PlaySound( byIndex );
        bPaused = FALSE;
        bStopped = FALSE;

        continue;
      }
      continue;
    }
  }
#endif
  return 0;
}
